#ifndef _BASESTAT_H_
#define _BASESTAT_H_

using namespace std;

#include <iostream>
#include <fstream>
#include <vector>
#include <ctype.h> // toupper()
#include "gmv_defs.h"

class codonfind{
private:
  int pos;

  char cdF[3], cdR[3];
  int statF; // fwd match stat: 0 = no match, 1,2,3 = Nth match
  int statR; // rev match stat

public:
  codonfind(){ init(); };

  void init();
  void setcodon(const char*);
  seqlen_t addbase(char);
};


class basestat{
protected:
  seqlen_t pos;
  // state variables
  bool repeat, unknown; 

  codonfind cdf[4]; // met + 3 stop codons

public:
  seqlen_t A, T, C, G, a, t, c, g, N, n;
  vector <seqlen_t> rs, re, us, ue; // {repeat,unknown}{start,end}
  string name;

  // start/stop for each reading frame
  vector <seqlen_t> startF[3], startR[3], stopF[3], stopR[3];   

  // constructor
  basestat();
  ~basestat();

  void clear();

  void init(string s);

  void finishup();
  void addseq(char* seq);
  void addfake(seqlen_t bp){ N+=bp; };

  seqlen_t totalbases(){ return A + T + C + G + a + t + c + g + N + n; }
  seqlen_t nonrepeats(){ return A + T + C + G + N; }
  seqlen_t repeats(){ return a + t + c + g + n; }

  int disp_summary();
  int disp_summary(bool verbose);
  string summary(){ return summary(false); };
  string summary(bool verbose);
};

#endif
