using namespace std;

#include <assert.h>
#include "dblinks.h"
#include <string.h>
#include <stdlib.h> // to define NULL... ?!
#include <stdio.h>
#include <iostream>
#include <gtk/gtk.h>

char* prepare_browser_command(const char* url){
#if defined (__APPLE__)
  const char* open_browser="open \"%s\"";
#else 
#if defined (__MINGW32__) 
  //const char* open_browser="cmd //c start %s ";
  const char* open_browser="rundll32 url.dll,FileProtocolHandler %s";
#else
  const char* open_browser="firefox \"%s\"&";   // it must be background
#endif
#endif

  int template_len = strlen(open_browser)+strlen(url)+10;
  char* cmd=(char*)malloc(template_len);

  snprintf(cmd, template_len-1, open_browser, url);

  assert(cout << cmd << endl);
  return(cmd);
}

void launch_browser(const char* url){
    char* browser_command = prepare_browser_command(url);
    // system(browser_command);
    g_spawn_command_line_async(browser_command, NULL);
    free(browser_command);
}

dblink dblinks[]={
  {"DOGAN", "DOGAN:",
   "http://www.bio.nite.go.jp/dogan/ProteinInformation?ORF_ID=%s"},
  {"NCBI GI",  "GI:", 
   "http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=Protein&val=%s"},
  {"KEGG Enzyme", "EC:", 
   "http://kegg.jp/dbget-bin/www_bget?enzyme+%s"},
  {"NCBI GeneID", "GeneID:", 
   "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?db=gene&cmd=Retrieve&dopt=Graphics&list_uids=%s"},
  {"GO annotation", "GOA:", 
   "http://www.ebi.ac.uk/ego/GSearch?query=%s&mode=name_syno&ontology=all_ont"},
  {"Interpro", "InterPro:", 
   "http://www.ebi.ac.uk/interpro/DisplayIproEntry?ac=%s"},
  {"NCBI Taxonomy", "taxon:", 
   "http://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?id=%s"},
  {"GeneDB", "GeneDB:", 
   "http://www.genedb.org/genedb/Dispatcher?formType=navBar&organism=All%3A*&desc=yes&submit=Search&name=%s"},
  {"UniProt", "UniProtKB/Swiss-Prot:",
   "http://www.pir.uniprot.org/cgi-bin/textSearch?s_field0=ALL&fieldNum=1&query0=%s"},
  {"UniProt", "UniProtKB/TrEMBL:", 
   "http://www.pir.uniprot.org/cgi-bin/textSearch?s_field0=ALL&fieldNum=1&query0=%s"},
  {"CDD", "CDD:", 
   "http://www.ncbi.nlm.nih.gov/Structure/cdd/cddsrv.cgi?uid=%s"},
  {"COG", "COG:COG", 
   "http://www.ncbi.nlm.nih.gov/COG/grace/wiew.cgi?%s"},
  {"COG", "COG:KOG",
   "http://www.ncbi.nlm.nih.gov/COG/grace/shokog.cgi?%s"},
  {"KEGG by Locus", "locus:", "http://www.genome.jp/dbget-bin/www_bfind_sub?mode=bfind&max_hit=1000&dbkey=kegg&keywords=%s"},
  {"DAS Link", "DAS_URL:", "%s"},
  {NULL, NULL, NULL}
};
