#ifndef _DIALOG_BASE_H
#define _DIALOG_BASE_H

// ----------------------------------------------------------------------
// general dialog handling
void handle_dialogResponse(GtkDialog*, gint, gpointer);

gboolean handle_release(GtkWidget* w, GdkEventButton *e, gpointer p);
gboolean handle_activate(GtkWidget* w, gpointer p);

class generalWidgets{
public:
  virtual void activate(GtkWidget*) = 0;
  virtual void release(GtkWidget*) = 0;
  virtual ~generalWidgets() = 0;
};

class generalDialog : public generalWidgets {
public:
  generalDialog(){ isOpen=false; dialog = NULL; };
  virtual void init(GtkWidget *) = 0;
  virtual void response(gint) = 0;
  virtual ~generalDialog() = 0;

  bool isopen() const { return isOpen && (dialog != NULL); };
  bool ismodal() const { 
    if(!isOpen) return false; 
    else return gtk_window_get_modal(GTK_WINDOW(dialog)); };
  void close(){ if(isOpen) response(GTK_RESPONSE_CANCEL); };
protected:
  bool isOpen;
  GtkWidget *dialog;
};

class generalAssistant : public generalDialog {
public:
  virtual ~generalAssistant() = 0;

  virtual void apply() = 0;
  virtual void close() = 0;
  virtual void cancel() = 0;
  virtual void prepare(GtkWidget*) = 0;

  void release(GtkWidget*){};
  void init(GtkWidget*){};
  void response(int){};

protected:

};

#endif
