using namespace std;

#include <iostream>
#include <stdlib.h>
#include "gbmisc.h"

pair<seqlen_t, seqlen_t> gb_detect_range(const string s){
  size_t f1, f2, t1, t2;
  const char* digits="0123456789";

  //  assert(cout << "gb_detect_range: " << s << endl);

  f1 = s.find_first_of(digits);
  f2 = s.find_first_not_of(digits, f1);

  if(f2 != string::npos){
    t1 = s.find_first_of(digits, f2);
    t2 = s.find_first_not_of(digits, t1);
  } else {
    t1 = f1;
    t2 = f2;
  }

  if(t2==string::npos) t2=s.length()+1;

  seqlen_t f = atoll(s.substr(f1, f2-f1).c_str());
  seqlen_t t = atoll(s.substr(t1, t2-t1).c_str());

  f--; // adjust because gmv is 0 origin
  if(f > t) swap(f, t);

  //  cout << "gb_detect_range(): " << f << "-" << t << endl;

  return pair<seqlen_t,seqlen_t>(f, t);
}
