#ifndef _GMV_DEFS_H_
#define _GMV_DEFS_H_


#ifndef REVISION
#define REVISION 999999 // failsafe
#endif

#define VERSION "1e-93"
#define RELEASE_NAME "Time goes by..."
#define RELEASE_DATE "Jun.28, 2012"

#define PROGBAR_UPDATE_INTERVAL 50 // timeout function is called every 50ms

#define MAXSEQ 255
#define HISTOGRAM_HEIGHT 100
#define HISTOGRAM_RESOLUTION 500

#define MAX_DRAFT_ANCS 10000

#define DEFAULT_PBCACHE_CAP 512

#define PLOT_CHROM_LINKS 0
#define PLOT_DOT 1
#define PLOT_SUPERZOOM 2
#define PLOT_ALL 99

#define ALPHA_BY_TFIDF 1
#define ALPHA_BY_CONST 2

#define COLOR_BY_POSITION 1
#define COLOR_BY_ANCHORLEN 2
#define COLOR_BY_TFIDF 3

#define NAME_AUTO 1
#define NAME_BY_GNAME 2
#define NAME_BY_LOCUS 3 
#define NAME_BY_PRODUCT 4

#define DISP_NAME_AUTO 1
#define DISP_NAME_ON   2
#define DISP_NAME_OFF  3

#define HOTSPOT_BY_DENSITY 1
#define HOTSPOT_BY_DENSITY_LOG 2
#define HOTSPOT_BY_RED 3
#define HOTSPOT_BY_PATTERN 4
#define HOTSPOT_BY_NUMBER 5
#define HOTSPOT_BY_COMBINATION 6

#define RIFT_FILTER_DONT_CARE 0
#define RIFT_FILTER_MUST_HAVE_RIFT 1
#define RIFT_FILTER_MUST_NOT_HAVE_RIFT 2

#define FILTER_POLICY_RANGE 0
#define FILTER_POLICY_COUNT 1

#define RANGE_FILTER_POLICY_AVG 0
#define RANGE_FILTER_POLICY_MINMAX 1

#define COUNT_FILTER_POLICY_COUNT 0
#define COUNT_FILTER_POLICY_PERCENTAGE 1

#define SORT_SOURCES_BY_WEIGHTED_AVERAGE 0
#define SORT_SOURCES_BY_AVERAGE 1
#define SORT_SOURCES_BY_MEDIAN 2
#define SORT_SOURCES_BY_LONGEST_ANCHOR 3

#define FONT_CHR "Sans Bold 12"  // for pango/cairo
// #ifndef __MINGW32__
// #  define FONT_CHR "Lucida Sans"    // for cairo (standalone)
// #else
// #  define FONT_CHR "Helvetica" // good for windoze, but really bad for Mac
// #endif

#define FONT_SIZE (status.font_size_general)

#define DEFAULT_FONT_SIZE_GENERAL 12
#define DEFAULT_FONT_SIZE_GENE 8

#define TICKS_OFFSET 10
#define THICKNESS_TICK 1

#define SPLASH_HEIGHT 528
#define SPLASH_WIDTH 720

#define DEFAULT_WIDTH 800
#define DEFAULT_HEIGHT 600
#define DEFAULT_MIN_SIZE 500
#define DEFAULT_MAX_SIZE 5000

#define DEFAULT_ZOOM_FACTOR 1.1

#define DEFAULT_WIN_WIDTH 888
#define DEFAULT_WIN_HEIGHT 663

#define THICKNESS_SEQ (status.sequence_thickness + (status.plot_O ? status.orf_thickness * 2 : 0))
#define THICKNESS_CHR (status.sequence_thickness)
#define THICKNESS_ORF (status.orf_thickness) // ORF bands above and below chromsome

#define DEFAULT_SEQUENCE_THICKNESS 4
#define DEFAULT_MIN_THICKNESS 0.3
#define DEFAULT_MAX_THICKNESS 2
#define DEFAULT_ORF_THICKNESS 6
#define DEFAULT_FILL_STROKE_RATIO 1.0
#define DEFAULT_CHRLINK_ENDCAP 0.2

#define MARGIN_SEQ  8

#define DEFAULT_MAX_WIDTH_GN 150
#define DEFAULT_MARGIN_GN 10
#define DEFAULT_MARGIN_LR 20
#define DEFAULT_MARGIN_TB 30 

#define DEFAULT_ANTIALIAS true
#define DEFAULT_SATURATION 1.0
#define DEFAULT_VALUE 1.0
#define DEFAULT_ALPHA_LOW 0.5
#define DEFAULT_ALPHA 0.7

#define DEFAULT_HUEDIFF 0 // was 45 before Sep.20, 2006
#define DEFAULT_DOT_RADIUS 1.5
#define DEFAULT_DOT_RADIUS_END 0

#define DEFAULT_PDF false
#define DEFAULT_PNG false

#define DEFAULT_PLOT_FWD true
#define DEFAULT_PLOT_BWD true

#define DEFAULT_CHR_NMASK false
#define DEFAULT_CHR_RMASK false
#define DEFAULT_CHR_ORF   false

#define DEFAULT_S 1.0
#define DEFAULT_V 1.0

#define DEFAULT_ZOOMCURSOR_WIDTH_PX 30
#define DEFAULT_ZOOMCURSOR_WIDTH_BP 10

#define DEFAULT_GENE_NAME_THRESHOLD 200
#define DEFAULT_GENE_WIDTH 10
#define DEFAULT_GENE_PADDING 1
#define DEFAULT_GENE_MARGIN 6

#define DEFAULT_MINORF 100
#define MINORF_MIN 1
#define MINORF_MAX 100000

#define MIN_POSSIBLE_SCORE 0.00000000000001

// ----------------------------------------------------------------------

#define MAX_SIZE_MIN 500
#define MAX_SIZE_MAX 10000
#define MIN_SIZE_MIN 200
#define MIN_SIZE_MAX 3000
#define DEFAULT_WIDTH_MIN 200
#define DEFAULT_WIDTH_MAX 10000
#define DEFAULT_HEIGHT_MIN 200
#define DEFAULT_HEIGHT_MAX 10000
#define ZOOM_FACTOR_MIN 1
#define ZOOM_FACTOR_MAX 3
#define SATURATION_MIN 0
#define SATURATION_MAX 1
#define FWDVALUE_MIN 0
#define FWDVALUE_MAX 1
#define BWDVALUE_MIN 0
#define BWDVALUE_MAX 1
#define BGVALUE_MIN 0
#define BGVALUE_MAX 1
#define ALPHA_MIN 0
#define ALPHA_MAX 1
#define SEQUENCE_THICKNESS_MIN 1
#define SEQUENCE_THICKNESS_MAX 32
#define MIN_THICKNESS_MIN 0.1
#define MIN_THICKNESS_MAX 5
#define MAX_THICKNESS_MIN 0.1
#define MAX_THICKNESS_MAX 10
#define FILL_STROKE_RATIO_MIN 0
#define FILL_STROKE_RATIO_MAX 1
#define CHRLINK_ENDCAP_MIN 0
#define CHRLINK_ENDCAP_MAX 0.3
#define PBCACHE_CAP_MIN 256
#define PBCACHE_CAP_MAX 2048
#define DOT_RADIUS_MIN 0
#define DOT_RADIUS_MAX 10
#define DOT_RADIUS_END_MIN 0
#define DOT_RADIUS_END_MAX 10
#define HUEDIFF_FB_MIN (double)0
#define HUEDIFF_FB_MAX (double)90
#define ZOOMCURSOR_WIDTH_PX_MIN 1
#define ZOOMCURSOR_WIDTH_PX_MAX 200
#define ZOOMCURSOR_WIDTH_BP_MIN 1
#define ZOOMCURSOR_WIDTH_BP_MAX 200

#define FONT_SIZE_MIN 4
#define FONT_SIZE_MAX 72

#define GENE_NAME_THRESHOLD_MIN 1
#define GENE_NAME_THRESHOLD_MAX (1024*1024*1024)

#define GENE_WIDTH_MIN 4
#define GENE_WIDTH_MAX 16
#define GENE_PADDING_MIN 0
#define GENE_PADDING_MAX 10
#define GENE_MARGIN_MIN 0
#define GENE_MARGIN_MAX 10

// ----------------------------------------------------------------------
//TYPEDEFs

using namespace std;

#include <set>

class geneMarkerRecord;

typedef geneMarkerRecord gene_marker_type;
typedef set <geneMarkerRecord> gene_markers_type;

#ifndef MICROBIAL
typedef long long int seqlen_t;
#else 
typedef int seqlen_t;
#endif

#endif
