#ifndef _HANDLER_TABLE_H_
#define _HANDLER_TABLE_H_

#define HANDLER_GENERAL 0
#define HANDLER_OPEN    1 // no longer used
#define HANDLER_DIALOG  2 
#define HANDLER_INSPECTOR 3
#define HANDLER_GID     4
#define HANDLER_STATD   5
#define HANDLER_REPD    6
#define HANDLER_BMARK   7
#define HANDLER_THUMBBAR 8

#include <gtk/gtk.h>
#include <set>
#include <vector>

using namespace std;

//typedef pair <gpointer,gulong> handler; // <instance, handler id>


class handler_table {
protected:
  class handler {
  public:
    gpointer instance;
    gulong   handler_id;
    int      type;
    handler(gpointer, gulong, int);
  };
  vector <handler> table;
  set <GtkWidget*> deactivated_widgets;
  int refcount;

 public:
  handler_table() : refcount(0) { };
  void connect(gpointer instance, int handler_type);
  void connect(gpointer instance, const char* signame, GCallback cb, gpointer data, int handler_type);
  void connect(gpointer instance, const char* signame, GCallback cb, gpointer data);
  void block();
  void unblock();
  void remove(gpointer instance);
  void remove_dialog();
  void remove_dialog(int t);
  void remove_widget(GtkWidget *w);
  void set_sensitive(GtkWidget*, bool);
protected:
};


#endif
