#include <iostream>
#include "messages.h"
#include "gmv_defs.h"
#include "util.h"

using namespace std;

string version_string(){
  char buf[1024];
  snprintf(buf, 1024, 
	   "GMV: a GTK+ powered murasaki viewer, from murasaki project\n\
version %s (build %d) [%s] (%s)",
	   VERSION, REVISION, RELEASE_NAME, RELEASE_DATE);

  return string(string(buf)); // start from 1e-200
}

string copyright_string(){
  return string("\n\
<b>Written by Yasunori Osana</b>\n\
@ Bioinformatics Lab., Keio University 2006-2008. \n\
@ Seikei University 2009.\n\
@ University of the Ryukyus 2012.\n\
\n\
<b>License:</b>\n\
\"THE BEER-WARE LICENSE\" (Revision 42):\n\
&lt;osana@dna.bio.keio.ac.jp&gt; wrote this file. As long as you retain this notice you can do whatever you want with this stuff. If we meet some day, and you think this stuff is worth it, you can buy me a beer in return Yasunori Osana.\n\
\n\
Binary distribution comes with some GPL'd stuff:\n\
- Mac binary: Platypus (http://www.sveinbjorn.org/platypus)\n\
- Windows binary: MinGW (http://www.mingw.org/)\n\
\n\
<b>Acknowledgement:</b>\n\
This work was supported by KAKENHI (Grant-in-Aid for Scientific Research) on priority areas \"Comparative Genomics\" from the Ministry of Education, Culture, Sports, Science and Technology of Japan.\n\
\n\
Also thanks to (alphabetical order):\n\
- Prof. Haruo Ikeda (Kitasato University)\n\
- Prof. Kazuhiko Saeki (Nara Womens University)\n\
- Dr. Kouichi Suzuki (National Institute of Infectious Diseases)\n\
- Mr. Kris Popendorf (Keio University)\n\
- Dr. Pieter Monsieurs (Belgian Nuclear Research Center)\n\
- Mr. Richard Hult (Imendio / GTK+-Quartz Developer)\n\
- Mr. Tsuyoshi Hachiya (Keio University)\n\
- Prof. Yasubumi Sakakibara (Keio University)\n\
- Dr. Yuko Sasaki  (National Institute of Infectious Diseases)\n\
- and every Murasaki &amp; GMV users!\n\
\n\
Special thanks to:\n\
- Coffe-Kan at Yutenji, Meguro Tokyo and its master, Kasashi-san\n\
- Hotel Jin-ya at Iijima, Nagano Japan\n\
- HUBS cafe at Amami Ooshima, Kagoshima Japan\n\
");
}

string history_string(){
  return string("\n\
<b>version 1e-93 [Time goes by...] (Jun.28, 2012)</b>\n\
Thread support for GLib-2.32+\n\
Recursive HTTP request for code 301 and 302.\n\
\n\
<b>version 1e-94 [Happy Birthday!] (Oct.03, 2009)</b>\n\
tmurasakix support!\n\
Support for GFF3 annotation + many improvements in GFF parser\n\
Fixed bug: Color for anchors with rift on seq #0\n\
Fixed bug: Clipping of exon/intron plot\n\
\n\
<b>version 1e-95 [The Peach Day] (Mar.03, 2009)</b>\n\
Fixed bug: GTK+ event signal may loop and thus causes crash\n\
Fixed bug: Now GMV can launch Web browser on Windows Vista (needs the latest GTK+ runtime lib)\n\
Rifts filter on inspector / command line option (-orift_filter)\n\
Color selector on inspector supports custom colors for:\n\
- anchors with rifts\n\
- annotations\n\
Sidebar and menubar rearrangement.\n\
Proper zoom cursor handling with GDK, now GMV can work with GDK-Quartz backend!\n\
\n\
<b>version 1e-96 [4 days to Grand Depart] (Jul.01, 2008)</b>\n\
Born-again sequence order controller on sidebar!\n\
Try to find .anchors.stats.tfidf in addition to .stats.tfidf\n\
New feature: \"Rifts\" display for Murasaki version 1.33\n\
New feature: Manual segment sort dialog\n\
Fixed bug: \"Open Anchor File\" menu may cause crash :p\n\
\n\
<b>version 1e-97 [Tour de Swiss] (Jun.17, 2008)</b>\n\
New feature: sort chromosomes, scaffolds, contigs etc. along a reference sequence\n\
Fixed bug: DAS import dialog may have contention with update notifier!\n\
\n\
<b>version 1e-98 [Contador conquers Giro!] (Jun.04, 2008)</b>\n\
Fixed bug: fixed timestamp check to not re-generate .stats.tfidf given by murasaki\n\
Fixed bug: gmv no longer dies when tfidf score &lt;= 0\n\
Fixed bug: renaming sequences with -n option fixed (was useless with FASTAs + .len files)\n\
Fixed bug: reordering sequences on sidebar / inspector fixed (was completele useless with 4+ sequences!)\n\
\n\
<b>version 1e-99 [Deadline! Deadline!!] (May.08, 2008)</b>\n\
Bookmarks are no longer flushed by loading sequences/annotations.\n\
Also, bookmarks are saved automatically (except in cases of unexpected termination).\n\
\n\
<b>version 1e-100 [Paris-Roubaix: Tom got it!] (Apr.22, 2008)</b>\n\
\"Alpha by tf-idf\" mode is now default: many default values are changed.\n\
Improved GenBank annotation parser: close to perfect?\n\
Cool splash screen :)\n\
Pango-based text renderer is back (was done by Cairo since 1e-186, Sep.27, 2006)\n\
Relative tick labels for very zoomed up plots\n\
Fixed bug: Thumbnail buttons may not work (... why were they working correctly?)\n\
Fixed bug: \"Gene Search\" results on GID spanning multiple pages may cause crash\n\
Fixed bug: gene reports may appear at inappropreate tab on report (due to the filter's bug...)\n\
Fixed bug: .anchors.details without hash details can't be loaded\n\
Fixed bug: Thumbnail bar wasn't cleared when new anchor file is loaded\n\
Fixed bug: \"type\" field in gene info dialog isn't cleared properly\n\
Fixed bug: Many bugs on histogram handling on inspector are fixed\n\
Fixed bug: Toggling \"show connected gene\" on gene info dialog has no immediate effect\n\
Fixed bug: \"add bookmark\" causes crash since 1e-101\n\
\n\
<b>version 1e-101 [Gent-Wevelgem: Fumy at 39th] (Apr.10, 2008)</b>\n\
More improved thumbnail bar, fixed many related bugs\n\
Limited history thumbnails to 50\n\
\"protect\" checkbox on history thumbnails\n\
Fixed bug: anchor filter is not applied on \"double-click to justify\" feature\n\
Fixed bug: anchor filter is not applied on gene info dialog's connection list\n\
\n\
<b>version 1e-102 [Forestrie] (Apr.09, 2008)</b>\n\
Improved thumbnail bar\n\
Fixed bug: double-click on an anchor may cause unexpected crash\n\
\n\
<b>version 1e-103 [Ronde Van Vlaanderen: Stijn Devolder] (Apr.07, 2008)</b>\n\
Check availability of new release at startup\n\
.cds is loaded for FASTA and .stitch files\n\
Thumbnail / Bookmark bar available!\n\
\n\
<b>version 1e-104 [Paris-Nice: Gert Steegmans] (Mar.12, 2008)</b>\n\
Seqname consistency between multi-fasta and GTF files.\n\
Quick annotation loading by File->Load Annotation (or Ctrl+A)\n\
\n\
<b>version 1e-105 [SGMJ '08] (Mar.10, 2008)</b>\n\
Murasaki 1.2's \".repeats\" support\n\
tf-idf calculation from .anchors.details\n\
Progress bar works while building segment tree\n\
Fixed bug: Strict timestamp checking on input files\n\
Fixed bug: Multithread renderer may cause crash\n\
Fixed bug: .anchors.details may not be loaded\n\
\n\
<b>version 1e-106 [Just one more thing...] (Feb.07, 2008)</b>\n\
Fixed bug: Fixed reverse anchors on dot plots\n\
\n\
<b>version 1e-107 [Robocop XP] (Feb.06, 2008)</b>\n\
Microbial genome edition is available \n\
Backward compatibility mode for GTK+-2.8\n\
Experimental multithread rendering on Windows\n\
.cds annotation (comes from Murasaki) support\n\
Fixed bug: Anchors on reverse strand weren't drawn correctly in recent version.\n\
Fixed bug: \"Go\" button on GID now works properly genes beyond 2Gbp\n\
\n\
<b>version 1e-108 [Please fix my MacBook...] (Jan.21, 2008)</b>\n\
Exon / Intron view support for DAS annotation sources\n\
.gz and .bz2 readability for sequence/annotation files\n\
Fixed bug: GMV couldn't load results by murasaki -H0 or -H1\n\
Fixed bug: Multithread FreeType contention is (almost) solved!\n\
Fixed bug: ticks in dot-plot was limited 2gb+\n\
Fixed bug: correct nucleotide # for anchor reports on reverse strand\n\
\n\
<b>version 1e-109 [GMV vs Windows] (Jan.09, 2008)</b>\n\
Sidebar toggle in \"View\" menu!\n\
More multithread renderer stability\n\
Fixed bug: correct N mask position\n\
Fixed bug: gdk_threads_init() is no longer called on Windows\n\
\n\
<b>version 1e-110 [Heavy Rain!] (Dec.29, 2007)</b>\n\
Fixed bug: score markers don't appear if all records in a GFF file have same score\n\
Fixed bug: name of annotation track has been disappeared since multithreaded rendering was enabled, but now they're visible.\n\
Fixed bug: annotation report crashes when tfidf score isn't available\n\
Fixed bug: gmv sometimes unexpectedly freezes in starting up process\n\
Fixed bug: correct handling of negative nucleotide # in DAS annotation\n\
Fixed bug: empty annotation track is shown incorrectly in report\n\
Fixed bug: dot-plot's source boundary wasn't drawn properly when seq #1 is the longest\n\
64bit nucleotide # migration\n\
\n\
<b>version 1e-111 [Azusa 8 to Shinjuku] (Nov.21, 2007)</b>\n\
Experimental multithreaded rendering\n\
Better clipping with cairo_clip()\n\
\n\
<b>version 1e-112 [Happy Pucchin Pudding] (Nov.12, 2008)</b>\n\
Fixed bug: proper handling of DAS server list in ~/.gmv\n\
Better default window size for DAS server manager\n\
More on ORF view\n\
\n\
<b>version 1e-113 [Congratulations Nori &amp; Hallca!] (Nov.04, 2008)</b>\n\
Fixed bug: infinite auto_save options in ~/.gmv while it's off!!\n\
Improved ORF view (oh, I love it!)\n\
\n\
<b>version 1e-114 [Long time no see...] (Nov.03, 2007)</b>\n\
Fixed bug: correct positioning of annotation track labels and markers\n\
Fixed bug: default combo box selection on DAS import dialog has been fixed.\n\
Fixed bug: memory leaks and some strange behavior in DAS import\n\
Fixed bug: weird gene may appear with some GenBank files (thanks to Prof. Ikeda @ Kitasato University\n\
Preference auto-save toggles in \"file\" menu.\n\
Some more auto-saved preferences: \"Auto Apply\" toggles on inspector.\n\
\"Reset GMV\" in \"file\" menu\n\
EC number lookup on DBGET\n\
Save imported DAS annotations in XML format.\n\
Load DAS formatted XML files as annotation\n\
Generates \"*.length\" file for FASTA formatted sequences (as murasaki does)\n\
\n\
<b>version 1e-115 [Happy Mid-Autumn Day] (Sep.27, 2007)</b>\n\
Note, function and translation on gene info dialog (if available)\n\
More query options on gene info dialog's \"search\" tab\n\
\n\
<b>version 1e-116 [Shibajun on TV] (Aug.04, 2007)</b>\n\
.gmv remembers previously selected DAS server, source and segment\n\
Fixed bug: DAS import no longer crashes on Windows (but it's not my bug!)\n\
\n\
<b>version 1e-117 [29.1km/h] (Aug.03, 2007)</b>\n\
User defined DAS server by server management dialog\n\
Fixed bug: preference couldn't be correctly saved in ~/.gmv\n\
\n\
<b>version 1e-118 [Hello again, Annotations] (Jul.31, 2007)</b>\n\
DAS import feature\n\
Code cleanups in progressbar handling\n\
Fixed bug: name of annotation tracks no longer get lost\n\
\n\
<b>version 1e-119 [Mauricio Soler] (Jul.18, 2007)</b>\n\
Fixed bug: correct handling of annotation tracks on inspector\n\
Fixed bug: no longer crashes by generating report with any GFF file with \"/gene=\" property\n\
\n\
<b>version 1e-120 [Fabian Cancellara] (Jul.13, 2007)</b>\n\
Report dialog shows variance of tfidf/expression scores beside their average.\n\
Incredible speedup of report featues with segment tree.\n\
Fixed bug: \"apply\" and \"OK\" on inspector resets some items (including new annotation tracks)\n\
\n\
<b>version 1e-121 [ANA416 to Tokyo] (Jun.28, 2007)</b>\n\
Sequence reordering on quickbar\n\
Tooltips on quickbar &amp; inspector\n\
Justification status dialog is integrated in mainwindow\n\
\n\
<b>version 1e-122 [Cheese Cake @ Kobe] (Jun.27, 2007)</b>\n\
Sequence reordering &amp; toggling on inspector\n\
\n\
<b>version 1e-123 [Butter Cake @ Hiroshima] (Jun.25, 2007)</b>\n\
Window size is automatically saved in the prefs file at exit\n\
Sequence name can be changed from inspector\n\
New interactive justification mode: circular justification by repeating double-clicks\n\
Gene connection report can refer COG database\n\
Fixed bug: genbank parser crashes with range spec of 1bp\n\
\n\
<b>version 1e-124 [Mega Teriyaki] (Jun.18, 2007)</b>\n\
Preferences can be saved, and loaded at startup!\n\
Fixed bug: report dialog fixed for sequences with no annotation\n\
\n\
<b>version 1e-125 [svn revision 555: 5^3=125] (Jun.17, 2007)</b>\n\
Sequence renaming feature is moved from conf dialog to inspector\n\
Many improvements in annotation track management on inspector\n\
Fixed bug: arrows for expression scores were inverted!!!!\n\
Fixed bug: saving report may cause crash\n\
\n\
<b>version 1e-126 [tax! tax! tax! ah.] (Jun.15, 2007)</b>\n\
gene connection report has filtering &amp; COG ortholog test feature\n\
Annotation track with both of score &amp; name appears on gene reports\n\
Many bugfixes\n\
\n\
<b>version 1e-127 [Eyesight 2.0] (Jun.14, 2007)</b>\n\
Avoid empty annotation tracks\n\
Gene connection report for anchor-based gene prediction available\n\
Report filter by features (CDS, mRNA, tRNA, etc.)\n\
Default radius for dot plot has been changed (smaller and better)\n\
Many bugs in report dialog fixed\n\
Snapshot builds available!\n\
\n\
<b>version 1e-128 [2^7] (Jun.04, 2007)</b>\n\
Fixed bug: tf-idf score wasn't loaded by \"Open Anchors\" from GUI\n\
\n\
<b>version 1e-129 [open(source);] (Jun.01, 2007)</b>\n\
\"source\" feature support GenBank file\n\
Limited support for murasaki's \".stitch\" format\n\
\n\
<b>version 1e-130 [10 x Golgo 13] (May.29, 2007)</b>\n\
Updated GenBank reader (get more info / cope with weird files)\n\
stats.tfidf is loaded instead of anchors.details (if exist)\n\
Filter report follows \"name by\"\n\
Non-filterable tracks have been excluded from filter report\n\
DOGAN dblink for sequences imported from NITE\n\
KEGG locus tag search\n\
\n\
<b>version 1e-131 [Color Copier] (May.08, 2007)</b>\n\
GLib regex search was broken and now fixed\n\
Fixed bug: histogram isn't cleared properly by File->Open\n\
\n\
<b>version 1e-132 [Van Houten] (Apr.24, 2007)</b>\n\
Error dialogs for missing files\n\
\n\
<b>version 1e-133 [Tour de Yatsugatake] (Apr.19, 2007)</b>\n\
Removed zoomer from quickbar\n\
Reorganized \"View\" menu\n\
Reorganized Quickbar\n\
Fixed bug: gene name tip should be cleared when mainwindow losts focus\n\
\n\
<b>version 1e-134 [Parix-Roubaix] (Apr.13, 2007)</b>\n\
Bookmark feature available\n\
Shortcut button to load seq &amp; show ORF on quickbar\n\
ORF cutoff configuration from commandline option\n\
Fixed bug: some command line opts were shown wrong in --help message\n\
Fixed bug: progress bar goes wrong while showing ORF\n\
\n\
<b>version 1e-135 [Ronde van Vlaanderen] (Apr.11, 2007)</b>\n\
ORF discovery + display\n\
Repeat / N masks on chromosome are disabled by default\n\
Fixed bug: incorrect zoomable area handling\n\
Fixed bug: incorrect clipping in zoomed plot\n\
\n\
<b>version 1e-136 [Breakaway] (Mar.21, 2007)</b>\n\
correct 1-origin bp# in reports\n\
Fixed bug: pangoTabArray memory leaks\n\
\n\
<b>version 1e-137 [On the Road Again!] (Mar.07, 2007)</b>\n\
More on Anchor/Gene filter report (now with save to file feature)\n\
Fixed bug: gene highlights by gid::search appears in dot-plot...\n\
Improved: now gene filter affects gid::search\n\
\n\
<b>version 1e-138 [Deadline Driven] (Feb.27, 2007)</b>\n\
Anchor/Gene filter report ++\n\
\n\
<b>version 1e-139 [Happy Birthday to ME] (Feb.21, 2007)</b>\n\
Extended expression filter feature\n\
Anchor/Gene filter report dialog\n\
Fixed bug: anchor based gene tracing by gid::browse was broken\n\
\n\
<b>version 1e-140 [Thomas Dekker] (Feb.15, 2007)</b>\n\
New Feature: gene filter by expression data in annotation track(s)\n\
\n\
<b>version 1e-141 [Damiano Cunego vola sui Tornado] (Feb.13, 2007)</b>\n\
New Feature: anchor filter by expression data in annotation track(s)\n\
\n\
<b>version 1e-142 [Shu-mai from Kiyouken] (Feb.12, 2007)</b>\n\
Gene marker filtering by anchor existence and tf-idf score\n\
\n\
<b>version 1e-143 [Runway 35 is clear for landing] (Feb.07, 2007)</b>\n\
Fixed bug: annotation track unload may cause crash\n\
Fixed bug: crashes with -r and -a together\n\
\n\
<b>version 1e-144 [Tour of Quatar] (Feb.03, 2007)</b>\n\
More on anchor statistics:\n\
  \"Detailed statistics\" can be generated from GUI!\n\
  HTML report for statistics with browser launcher\n\
Fixed bug: bases other than ATGC (such as pyrimidine) was ignored\n\
\n\
<b>version 1e-145 [Tour of Siam] (Jan.31, 2007)</b>\n\
Fixed bug: gmhilight::flush() may crash\n\
\n\
<b>version 1e-146 [Allez, Takashi!] (Jan.30, 2007)</b>\n\
Fixed default window location\n\
Some default values has been changed\n\
Inspector::zoom reference point moved from left end to center\n\
\"Click to Zoom\" on GID::search\n\
Fixed bug: sequence toggling causes crash at anchor/gene justification\n\
Fixed bug: GID doesn't work with seq reorder/toggle at all\n\
\n\
<b>version 1e-147 [Hello Bill, again] (Jan.25, 2007)</b>\n\
Recovered Windows compatibility with glib pattern matching\n\
Fixed Bug: MinGW compatibility is lost (because of regex.h)\n\
Fixed bug: floating exception in annotation track allocator\n\
\n\
<b>version 1e-148 [Tour Down Under] (Jan.23, 2007)</b>\n\
annotation string search!!!\n\
Known bug: lost MinGW compatibility (regex.h doesn't exist!)\n\
Fixed bug: -d gene_markers didn't affect on track names\n\
Fixed bug: memory leak (inspector pages aren't deleted!)\n\
Fixed bug: overwrapped marker highlights aren't cleared correctly\n\
\n\
<b>version 1e-149 [Overdrive: vol.9] (Jan.19, 2007)</b>\n\
name on annotation tracks\n\
tf-idf filter to justify sequences\n\
Fixed bug: Gene markers should be 0 origin (as anchors are)!\n\
Fixed bug: GID requires scrollbar...\n\
\n\
<b>version 1e-150 [Cycles Gladiator 2004] (Jan.17, 2007)</b>\n\
tf-idf upper threshold filter\n\
Fixed bug: undo/redo support on annotation track toggling\n\
\n\
<b>version 1e-151 [Keep hanging on, Jan!] (Jan.16, 2007)</b>\n\
DB links on GID (gene info dialog) are available\n\
GtkFileFilter is applied on file choosers\n\
Fixed Bug: genes included in a long anchor will not be traced by GID\n\
Fixed Bug: dialogs must be closed when loading new anchor file\n\
\n\
<b>version 1e-152 [Route 152: Heading North] (Jan.15, 2007)</b>\n\
Annotation track management in GMV Inspector\n\
Fixed bug: tf-idf filter did't affect on dot plot!\n\
\n\
<b>version 1e-153 [Happy Birthday, Sir] (Jan.10, 2007)</b>\n\
GFF files are loadable! (mostly for expression data import)\n\
Strict clipping is now default\n\
Sticky display is now default in GID\n\
More sample files included\n\
Fixed bug: gene marker highlights aren't cleared when GID is closed\n\
\n\
<b>version 1e-154 [Col de la Croix de Fer] (Jan.08, 2007)</b>\n\
ComboBox to show/hide/auto gene names\n\
Sophisticated handling of multiple annotation files\n\
Fixed bugs: so many\n\
\n\
<b>version 1e-155 [Col du Galibier] (Jan.05, 2007)</b>\n\
mv_status::order_seq[] is replaced by mv_status::seq_lookup(), with respect to seq toggling (this eliminate many potential bugs)\n\
Fixed bug: GID is completely useless with sequence toggling...\n\
Fixed bug: seq reordering doesn't work with dot plots\n\
Fixed bug: ticks aren't numbered in dot plots\n\
\n\
<b>version 1e-156 [l'Alpe d'Huez] (Jan.04, 2007)</b>\n\
genename tip beside the mouse pointer\n\
\"clip hard\" option for happy gene hunting\n\
gene marker highlighting\n\
anchored gene marker highlighting\n\
Fixed bug: thin markers are ignored by gene info dialog and so on\n\
Fixed bug: undo/redo makes gene marker list broken!!\n\
Known bug: gene info dialog doesn't work with seq toggling\n\
\n\
<b>version 1e-157 [bye bye 2006] (Dec.31, 2006)</b>\n\
MinGW/WindowsXP compatible Makefile\n\
New option: -e quick_load  (skip loading seq)\n\
New option: -e veryquick_load (skip loading annotation + seq)\n\
Fixed bug: gene names can't be cleared if once forced\n\
\n\
<b>version 1e-158 [JIS Keyboard] (Dec.27, 2006)</b>\n\
New feature: anchored genes on other seqs (gene info dialog)\n\
New feature: gmv.app, the software package for MacOS\n\
\n\
<b>version 1e-159 [Merry Christmas] (Dec.25, 2006)</b>\n\
New feature: gene information dialog\n\
Inspector is a now non-modal dialog\n\
\n\
<b>version 1e-160 [Live to Hack?] (Dec.23, 2006)</b>\n\
tf-idf histogram on inspector\n\
improved tf-idf coloring method (with cutoff at 99.5%)\n\
\n\
<b>version 1e-161 [Give us fork(), Bill!!] (Dec.21, 2006)</b>\n\
Windows (MinGW) support! Yeah!\n\
Effort on Makefiles\n\
\n\
<b>version 1e-162 [Basso comes again!] (Dec.19, 2006)</b>\n\
Direction notch on gene markers\n\
Fixed bug: a dialog should given if load error happens\n\
\n\
<b>version 1e-163 [Escape: this is my philosophy] (Dec.18, 2006)</b>\n\
Select anchor to align if there's any overwrapped ones.\n\
Code cleanup in mv_status::copy()/backup()/restore()\n\
Fixed bug: configuration window crashes by second \"apply\"\n\
\n\
<b>version 1e-164 [Rainy days...] (Dec.13, 2006)</b>\n\
New coloring method: tf-idf\n\
\n\
<b>version 1e-165 [Flight NH7 to Tokyo] (Dec.10, 2006)</b>\n\
Source tree has been restructured (most of files are moved to src/)\n\
Name of anchor file on window title\n\
Automatic .anchors.details detection and loading\n\
tf-idf filter dialog on inspector\n\
Fixed bug: offset was't cleared by results::clear()\n\
Fixed bug: redraw() is called many times by \"apply\" on inspector\n\
\n\
<b>version 1e-166 [Zunda-mochi] (Nov.27, 2006)</b>\n\
Integrated control dialog has been introduced!\n\
\n\
<b>version 1e-167 [mou] (Nov.27, 2006)</b>\n\
Fixed bug: proper command line option handling on 64bit systems\n\
\n\
<b>version 1e-168 [moo] (Nov.25, 2006)</b>\n\
Code cleanup in quickbar and dialogs\n\
Proper \"Color By\" handling\n\
\"Name By\" for gene annotation\n\
Fixed bug: sequence check box must be flushed in flush_and_redraw()\n\
\n\
<b>version 1e-169 [Beaujolais Nouveau] (Nov.19, 2006)</b>\n\
Locus ID or product name is displayed if there's no gene name\n\
New DB: locus tag can be queried in DBGET+KEGG\n\
Fixed bug: can't load *.seqs file with any blank line\n\
Fixed bug: there are 2 functions bound to Ctrl+Z! (undo and zoom control)\n\
Fixed bug: forward/backward buttons on zoom control dialog cause crash\n\
Fixed bug: mousepointer motion before Kris appears causes crash\n\
Fixed bug: quick_color doesn't configured by set_quickbar()\n\
Fixed bug: gene markers spread all over screen when endcap is too small\n\
\n\
<b>version 1e-170 [Un Deux Trois] (Nov.11, 2006)</b>\n\
Undo / Redo !\n\
\n\
<b>version 1e-171 [DB Connected!] (Nov.10, 2006)</b>\n\
Anchor context menu: provides DB connectivity\n\
(default browser on MacOS X, firefox on others)\n\
Step width control on zoom control dialog\n\
Fixed bug: stabilized annotation markers allocation\n\
\n\
<b>version 1e-172 [Need more effort?] (Nov.08, 2006)</b>\n\
New anchor coloring method: by anchor length\n\
Left/center/right preset button on sequence position dialog\n\
Purged all deprecated GTK/GDK/GLIB stuff\n\
\n\
<b>version 1e-173 [Vladimir Gusev] (Nov.06, 2006)</b>\n\
Left/right/center preset offset\n\
Gene width / margin are now configurable\n\
file_selection is replaced by file_chooser_dialog\n\
gene_name_auto &amp; gene_markers are now defaults\n\
Fixed bug: genbank files without LOCUS at their head must be readable\n\
Fixed bug: \"cancel\" on sequence position dialog may cause GTK errors\n\
\n\
<b>version 1e-184 [Ruggero Marzoli] (Oct.25, 2006)</b>\n\
Click-to-Align feature is added.\n\
\n\
<b>version 1e-175 [Riccardo Ricc嘆] (Oct.23, 2006)</b>\n\
Gene marker toggles on quickbar.\n\
Annotations are automatically loaded from Genbank files.\n\
Better file path management (simple path estimation).\n\
Now .block files are also accepted as .anchors.\n\
Fixed bug: correct placement of gene markers with offsets.\n\
Fixed bug: sequence # in sequence position dialog.\n\
Fixed bug: annotations are flushed when new anchors are loaded.\n\
\n\
<b>version 1e-176 [Vino por favor!] (Oct.20, 2006)</b>\n\
Sequence position control dialog.\n\
Better \"Apply Automatically\" handling on zoom/position dialogs.\n\
\n\
<b>version 1e-177 [Red Pepper Chocolate] (Oct.18, 2006)</b>\n\
-s option shifts sequence position.\n\
-r option is now OK again.\n\
\n\
<b>version 1e-178 [Milk Chocolate] (Oct.16, 2006)</b>\n\
Command line options are cleaned up from scratch.\n\
+ major code cleanup.\n\
\n\
<b>version 1e-179 [Born to Debug] (Oct.12, 2006)</b>\n\
Splash screen update.\n\
Font size and thickness of sequence are configurable.\n\
-ofont_size=XX,font_size_gene=XX.\n\
New option: -o\n\
<b>version 1e-180 [Genetic Debugging] (Oct.11, 2006)</b>\n\
GenBank files can be loaded as annotation data! Yeah!\n\
New option: -A (load genbank files)\n\
New option: -g (enable gene markers)\n\
New option: -G (enable gene names / with threshold)\n\
\n\
<b>version 1e-181 [Penguin] (Oct.05, 2006)</b>\n\
Bug fixed: now zoom cursor doesn't disturb range information.\n\
\n\
<b>version 1e-182 [Cache, Cache, Cache!] (Oct.05, 2006)</b>\n\
Superzoom image caching.\n\
\n\
<b>version 1e-183 [Sort, Sort, Sort!] (Oct.04, 2006)</b>\n\
Automatic sequence ordering mechanism.\n\
\n\
<b>version 1e-184 [Oooooops!!!] (Oct.03,2006)</b>\n\
Bug fix release. Fixed confin crash.\n\
\n\
<b>version 1e-185 [Prepare Your Slide!] (Oct.03,2006)</b>\n\
Config window has been written with GtkDialog.\n\
Progress bar while loading anchors.\n\
Improved sequence statistics.\n\
(.stat file can be disabled by --disable=statistics)\n\
\n\
<b>version 1e-186 [Because it was Raining] Sep.27, 2006</b>\n\
Zoom controller release.\n\
Cairo+pango rendering is replaced by cairo standalone rendering.\n\
Zoom cursor is now thread safe.\n\
\n\
<b>version 1e-187 [Because it's Raining] Sep.27, 2006</b>\n\
Zoom controller preview release (with some bugs :p )\n\
\n\
<b>version 1e-188 [Flight NH150] Sep.22, 2006</b>\n\
\"Endcap\" on chrom-link view.\n\
New option: -e (endcap length ratio)\n\
-e0 is equivalent to older versions.\n\
\n\
<b>version 1e-189 [Hanshin Tigers 77] Sep.22, 2006</b>\n\
Code cleaning has been done.\n\
Ability to set different color values for Fill &amp; Stroke.\n\
New option: -S (fill/stroke value ratio)\n\
\n\
<b>version 1e-190 [Osaka Okonomiyaki] Sep.21, 2006</b>\n\
Internal structure of configuration window is much improved!\n\
(This will avoid unexpected crashes in config window.)\n\
# of anchors is displayed in sequence statistics window.\n\
\n\
<b>version 1e-191 [Osaka Takoyaki] Sep.20, 2006</b>\n\
New option: -c (superzoom cursor width in bp)\n\
New option: -C (superzoom cursor width in px)\n\
New option: -x (disable range / seq # display)\n\
\"Superzoom\" feature for chrom-link view\n\
\n\
<b>version 1e-192 [Vuelta Espana] Aug.27, 2006</b>\n\
First version with this \"version history\"\n\
New option: -a (alpha value)\n\
New option: -r (sequence reordering)\n\
New option: -p (plot sequence selection)\n\
Keyboard shortcuts on sequence toggling\n\
Bug fix in vertical chromosome bands drawing of dot-plot\n\
");
}

void version(){
  cout << version_string()  
       << endl;
}

string usage_string(){
  return string("\
Usage: gmv [options...] you_want_to_see_the.anchors\n\
       It is highly recommended to Launch gmv at the directory \n\
       where you launched murasaki.\n\
\n\
  -t,--plot-type=<type>\n\
       Select default plot type ('link'(default) or 'dot').\n\
       'all' is available for file output.\n\
 \n\
  -f,--file-output=<type>\n\
       Plot on image files instead of the screen.\n\
       'png', 'pdf' and 'all' are available.\n\
\n\
  -n,--sequence-names=<seq#1 name, seq#2 name, seq#3 name, ...>\n\
       Set favourite name for each sequence.\n\
      \n\
  -r,--reorder-seq=<seq# for 1st, seq# for 2nd, seq# for 3rd, ...>\n\
       Reorder sequences as you like.  For example, -r3,2,1 will\n\
       display 3 sequences in reverse order.\n\
       \n\
  -m,--mask-seq=<mask>\n\
       Show/hide sequences.  For example, '101' shows seq #1 and #3, \n\
       and hides seq #2.\n\
\n\
  -a,--annotation=<seq#:file[,file,...],seq#:file[,file,...], ...>\n\
       Assign annotation files to desired sequence. \n\
       GenBank format is supported.\n\
\n\
  -e,--enable=<option1,option2,option3, ...>\n\
       Enable one or more option(s) in:\n\
         [ general options ]\n\
         load_seq         : load sequence on startup (show ORFs etc.)\n\
         auto_order       : automatically sorts the sequences.\n\
         statistics       : generate detailed statistics in plaintext\n\
         statistics_html  : generate detailed statistics in HTML\n\
         rift_stencil     : do \"stencil\" drawing for rifts\n\
\n\
	 u_mask           : show unknown base marker on chromosome\n\
	 r_mask           : show repeat region marker on chromosome\n\
         repeat           : disable repeat marks\n\
              * u_mask and r_mask appears only when sequence is loaded\n\
              * repeat marks appears only when repeat data is loaded\n\
\n\
         [ link-view specific options ]\n\
         force_gene_name  : force display gene names (if marker is active)\n\
\n\
  -d,--disable=<option1,option2,option3, ...>\n\
       Disable one or more option(s) in:\n\
         [ general options ]\n\
         load_annotation  : force not load annotations\n\
         force_gene_name  : hide gene names always\n\
         gene_markers     : hide gene markers\n\
	 seqno            : hide sequence # in sequence name\n\
	 fwd              : hide forward anchors\n\
	 bwd              : hide backward anchors\n\
         rift_pattern_fill: do not fill anchors with rifts by stripe pattern\n\
\n\
         o_mask           : hide ORF markers on chromosome\n\
         repeat           : disable repeat marks\n\
              * o_mask appears only when sequence is loaded\n\
              * repeat marks appears only when repeat data is loaded\n\
\n\
         [ link-view specific options ]\n\
         range   : show bp range information on top left corner\n\
         force_gene_name  : force hide gene names\n\
\n\
  -o,--options=<var1=val1,var2=val2,var3=val3,...>\n\
       Set one or more variable(s) in:                 [default  min   max ]\n\
         [ general options ]\n\
\n\
         min_orf        : ORF cutoff length            [   100     1  100k ]\n\
         min_tfidf      : minimum tf-idf score to show [     0     0   n/a ]\n\
\n\
         font_size      : general font size            [    12     4    72 ]\n\
	 font_size_gene : font size for gene name      [    12     4    72 ]\n\
         seq_thickness  : thickness of sequence        [     8     1    32 ]\n\
         orf_thickness  : thickness of sequence        [     6     1    32 ]\n\
\n\
	 width          : default canvas width         [   800   200 10000 ]\n\
	 height         : default canvas height        [   600   200 10000 ]\n\
	 min_size       : min. canvas size (w & h)     [   500   200 10000 ]\n\
	 max_size       : max. canvas size (w & h)     [  5000  3000 10000 ]\n\
	 zoom_factor    : zoom step factor             [   1.1     1     3 ]\n\
\n\
	 alpha          : alpha value of anchors       [     1     0     1 ]\n\
	 saturation     : saturation of anchors        [     1     0     1 ]\n\
	 value_fwd      : value for fwd anchors        [     1     0     1 ]\n\
	 value_bwd      : value for bwd anchors        [     1     0     1 ]\n\
	 value_bg       : value of background          [     1     0     1 ]\n\
	 fl_contrast    : fill / line contrast\n\
\n\
         rift_filter    : \"rifts\" filter. 1 digit for 1 sequence to\n\
                          set the filter policy:  0 = don\'t care, \n\
                          1 = must have rifts, 2 = must not have rifts.\n\
                          For example, \"-orift_filter=020\" removes all \n\
                          anchors with rifts on sequence 2.\n\
\n\
         cog            : COG ortholog list file (the name should be \"whog\") \n\
\n\
         [ link-view specific options ]\n\
	 cursor_bp      : zoomcursor width in bp       [    30     1   200 ]\n\
	 cursor_px      : zoomcursor width in px       [    10     1   200 ]\n\
\n\
	 max_thickness  : max. anchor thickness        [     2   0.1    10 ]\n\
	 min_thickness  : min. anchor thickness        [   0.1   0.1     5 ]\n\
                          (if too small, they\'ll be invisible!)\n\
\n\
	 endcap         : endcap length in link plot   [   0.2     0   0.3 ]\n\
	 endcap_na      : endcap length w/o annotation [   0.2     0   0.3 ]\n\
\n\
	 gene_name_auto : thresold to show gene name   [   200     1    1G ]\n\
\n\
         color_by       : anchor color by \"position\", \"length\" or \"tfidf\"\n\
\n\
	 [ dot plot specific options ]\n\
	 huediff_fb     : hue distance of fwd/bwd      [     0     0    90 ]\n\
\n\
   --help,-h\n\
       Show this usage.\n\
\n\
   --version,-v\n\
       Show version.\n\
");
}


void usage(){
  version();
  cout << usage_string();
}

