using namespace std;

#ifndef _ZOOM_CURSOR_H
#define _ZOOM_CURSOR_H

#include <gtk/gtk.h>

class zoom_cursor{
 public:
  bool active;
  bool button_on;
  bool dragging;

  // temp memory
  int prev_x1, prev_x2;
  GdkPixbuf *cpb1, *cpb2; // copy & paste buffer (vertical)
  GdkPixbuf *cpb3, *cpb4; // copy & paste buffer (horizontal)
  
  int bd_x1, bd_x2, bd_y1, bd_y2; // borders
  int default_w; // default width
  int x1, x2;    // left & right X
  int p_x, r_x;  // pressed & released X
  int cursor_y, cursor_h;
  bool cursor_inside; 
  
  zoom_cursor();
  void init();

  void set_yh(int new_y, int new_h);
  void set_default_w(int new_w);
  void set_bound(int new_x1, int new_x2, int new_y1, int new_y2);
  void pressed(int x, int y);
  bool released(int x, int y);
  void move(int x, int y);
  void leave();
  void enter();
  void inactivate();
  void force_inside();
  void force_release();

 protected:
  GMutex *mutex;
  void paste();
  bool check_bound(int x, int y);
  void show();
};

#endif
